package mongodb

import (
	"crypto/tls"
	"net"
	"testing"

	osm "git.loafle.net/overflow/service_matcher-go"
)

func TestMongoNor(t *testing.T) {

	conn, err := net.Dial("tcp", "192.168.1.229:27036")
	if err != nil {
		t.Errorf("ERR %s", err)
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.229", 27036)

	MongoRun(matchCtx, conn, t)

}

func TestMongoTLS(t *testing.T) {
	conn, err := tls.Dial(
		"tcp",
		"192.168.1.229:27036",
		&tls.Config{
			InsecureSkipVerify: true,
			ServerName:         "192.168.1.229",
		},
	)
	if err != nil {
		t.Errorf("ERR %s", err)
	}
	defer conn.Close()

	matchCtx := osm.NewMatchCtx("192.168.1.229", 27036)

	MongoRun(matchCtx, conn, t)
}

func MongoRun(matchCtx *osm.MatchCtx, conn net.Conn, t *testing.T) {

	m := NewMatcher()

	for i := 0; i < m.PacketCount(matchCtx); i++ {

		pack := m.Packet(matchCtx, i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := osm.NewPacket(bytes, n)

		if err := m.Match(nil, i, p); err != nil {
			t.Error(err)
		}

	}
	t.Log(m.Name(matchCtx))
	t.Log(matchCtx)
}
